Main Page | Modules | Class Hierarchy | Alphabetical List | Class List | File List | Class Members | Related Pages

# SbPlaneProjector Class Reference
[Projector classes (mostly for internal use)]

`#include <Inventor/projectors/SbPlaneProjector.h>`

Inheritance diagram for SbPlaneProjector:

List of all members.

## Detailed Description

The SbPlaneProjector class projects 2D points to 3D points in a plane.

The 3D projection of the 2D coordinates is for this projector class constrained to lie inside a pre-defined 3D plane.

See also:
  SbLineProjector

## Public Member Functions
| SbPlaneProjector (const SbBool orient=FALSE)
| SbPlaneProjector (const SbPlane &plane, const SbBool orient=FALSE)
virtual SbProjector * | copy (void) const
virtual SbVec3f | project (const SbVec2f &point)
void | setPlane (const SbPlane &plane)
const SbPlane & | getPlane (void) const
void | setOrientToEye (const SbBool orienttoeye)
SbBool | isOrientToEye (void) const
virtual SbVec3f | getVector (const SbVec2f &viewpos1, const SbVec2f &viewpos2)
virtual SbVec3f | getVector (const SbVec2f &viewpos)
void | setStartPosition (const SbVec2f &viewpos)
void | setStartPosition (const SbVec3f &point)
## Protected Member Functions
void | setupPlane (void)
## Protected Attributes
SbPlane | plane
SbPlane | nonOrientPlane
SbBool | orientToEye
SbBool | needSetup
SbVec3f | lastPoint

## Constructor & Destructor Documentation

SbPlaneProjector::SbPlaneProjector | ( | const SbBool | orient = FALSE | ) |

| Constructor. Sets up a projection plane parallel with the XY-plane in world coordinates.

SbPlaneProjector::SbPlaneProjector | ( | const SbPlane & | plane,
|  | const SbBool | orient = FALSE
| ) |

| Constructor taking an explicit projection plane definition.

## Member Function Documentation

SbProjector * SbPlaneProjector::copy | ( | void |  | ) | const`[virtual]`

| Construct and return a copy of this projector. The caller is responsible for destructing the new instance. Note that if the Coin library has been built as a DLL under Microsoft Windows and you use this method from application code, you must make sure that both the Coin DLL and the application executable is using the same instance of a C Run-Time (CRT) library. Otherwise, you will get memory heap corruption upon deallocating the returned instances, eventually leading to mysterious crashes. Implements SbProjector.

SbVec3f SbPlaneProjector::project | ( | const SbVec2f & | point | ) | `[virtual]`

| Projects 2D point into a 3D point within the current projection plane. Implements SbProjector.

void SbPlaneProjector::setPlane | ( | const SbPlane & | plane | ) |

| Set a new projection plane.

const SbPlane & SbPlaneProjector::getPlane | ( | void |  | ) | const

| Returns the current projection plane.

void SbPlaneProjector::setOrientToEye | ( | const SbBool | orienttoeye | ) |

| Sets whether or not the plane should always be oriented towards the "eye" of the viewer.

SbBool SbPlaneProjector::isOrientToEye | ( | void |  | ) | const

| Returns the state of the plane orientation flag.

SbVec3f SbPlaneProjector::getVector | ( | const SbVec2f & | viewpos1,
|  | const SbVec2f & | viewpos2
| ) | `[virtual]`

| Returns a vector between the projected 3D points of viewpos1 and viewpos2.

SbVec3f SbPlaneProjector::getVector | ( | const SbVec2f & | viewpos | ) | `[virtual]`

| Returns a vector between the last projected point and the projected 3D point of viewpos.

void SbPlaneProjector::setStartPosition | ( | const SbVec2f & | viewpos | ) |

| Explicitly set position of initial projection, so we get correct values for later calls to getVector() etc.

void SbPlaneProjector::setStartPosition | ( | const SbVec3f & | point | ) |

| Explicitly set position of initial projection, so we get correct values for later calls to getVector() etc.

void SbPlaneProjector::setupPlane | ( | void |  | ) | `[protected]`

| Should be called whenever SbPlaneProjector::needSetup is `TRUE`. Will recalculate projection plane.

## Member Data Documentation

SbPlaneProjector::plane`[protected]`

| The projection plane.

SbPlaneProjector::nonOrientPlane`[protected]`

| The "original" plane which was set (as opposed to the recalculated projection plane according to the SbPlaneProjector::orientToEye setting).

SbPlaneProjector::orientToEye`[protected]`

| Which direction the plane is oriented.

SbPlaneProjector::needSetup`[protected]`

| Set to `TRUE` whenever the plane needs to be recalculated according to the setting of the SbPlaneProjector::orientToEye flag.

SbPlaneProjector::lastPoint`[protected]`

| Stores the previously projected 3D point.

The documentation for this class was generated from the following files:

- SbPlaneProjector.h
- SbPlaneProjector.cpp